/*--------------------------------------------------------------------------------------------+
| Name : config.h                                                                             |
| Purpose:                                                                                    |
| Define the common include files for the program, hardware pin connection and function       |
| protocol.                                                                                   |
+--------------------------------------------------------------------------------------------*/
#include <reg51.h>
#include <stdio.h>

// define hardware pin connection 
sbit CLK = P3^2;			// keyboard clock input pin
sbit KBDATA = P1^0;			// keyboard data input pin

// uart.c
void init_uart(void);
void init_int0(void);

// decode.c
bit isdispkey(unsigned char rcvdata);
bit isvalidcode(unsigned char rcvdata);
unsigned char scancode2Ascii(unsigned char sc);

//hex.c
void print_hexdata(unsigned char hexdata);
unsigned char hex2ascii(unsigned char bits_data);

//kbdata.c
unsigned char getrcvdata(void);

//simscancode.c
unsigned char simscancode(unsigned char a,b,c,d,e,f,g,h,i);

