/*--------------------------------------------------------------------------------------------+
| Name : hex.c                                                                                |
| Purpose:                                                                                    |
| Provide the function that will print the hexdata on screen through RS232 port.              |
+--------------------------------------------------------------------------------------------*/
#include"config.h"

/*
	print the value of hex data on screen
*/
void print_hexdata(unsigned char hexdata)
{
	static unsigned char hex_h;
	static unsigned char hex_l;
	hex_l = hex2ascii(hexdata&0x0f);					// convert low byte
	hex_h = hex2ascii((hexdata&0xf0)/0x0f);        		// convert high byte
	printf("%c%c",hex_h,hex_l);							// print out
}

/*
	convert the hex data(4 bits) to ascii code(8 bits)
*/
unsigned char hex2ascii(unsigned char bits_data)
{
	if(bits_data >=0x0f)								// all invalid data return 'F'
	{
		return 0x46;
	}
	if (bits_data >=0x00 & bits_data <=0x09)			// return '0'-'9'
	{
		bits_data +=0x30;
		return bits_data;
	}
	if (bits_data >=0x0a & bits_data <=0x0f);			// return 'A'-'F'
	{
		bits_data +=0x37;
		return bits_data;
	}
}