/*--------------------------------------------------------------------------------------------+
| Name : kbdata.c                                                                             |
| Purpose:                                                                                    |
| Get the keyboard scancode form the keyboard, and export it to other function.               |
| Ps: I have try to export and implement convertion directly when receive a newer scancode,   |
|     the method, however, is failed. The reason, i guess is the time is not enough before    |
|     another interrupt occur. So, i use a variable to store the scancode, process it and use |
|     the buffer that provided by the standard function printf().                             |
+--------------------------------------------------------------------------------------------*/
#include"config.h"

static unsigned char rcvdata;					// keyboard scancode data
static bit ok;									// scancode data validlity 

/*
	export the keyboard scancode, wait until a new scancode is received.
*/
unsigned char getrcvdata(void)
{
	while(!ok);									// wait until a scancode received.
	ok=0;										// when get the scancode, clear the ok state
	return rcvdata;
}

/*
	External interrupt 0 will triger the clock pin, as the bit count continues, the scancode
	data can be obtained and stored in variable rcvdata. Flag ok indicate the validable of the
	scancode data.
*/
void getkbData(void) interrupt 0
{
	static unsigned char maskdata,bitcount;
	bitcount++;
	// bit 2 to 9 is data, 10 is parity, 11 is stop bit and 1 is start bit
	switch(bitcount)
	{
		case 1:
				break;
		case 2:
				if (KBDATA==1)				
				maskdata |= 0x01;
				break;
		case 3:
				if (KBDATA==1)				
				maskdata |= 0x02;
				break;
		case 4:
				if (KBDATA==1)				
				maskdata |= 0x04;
				break;
		case 5:
				if (KBDATA==1)				
				maskdata |= 0x08;
				break;
		case 6:
				if (KBDATA==1)				
				maskdata |= 0x10;
				break;
		case 7:	
				if (KBDATA==1)				
				maskdata |= 0x20;
				break;
		case 8:
				if (KBDATA==1)				
				maskdata |= 0x40;
				break;
		case 9:
				if (KBDATA==1)				
				maskdata |= 0x80;
				rcvdata=maskdata;
				ok=1;
				break;
		case 10:				
				break;
		case 11:
				bitcount=0;
				maskdata=0x00;				
				break;
	}// end of switch
}



